#ifndef STDIO_H
  #define STDIO_H
  #include <stdio.h>
#endif

#include "list_rank.h"

l_rank new_rank()
{
   	return((l_rank)NULL);
}

l_rank insert_rank(int rankid, int upper, int lower, l_rank list)
{
   	l_rank adv, n_rank, ant;

   	adv = list;
   	if(exists_rank(rankid, list))
		return(list);
   	if(!(n_rank = (l_rank)malloc(sizeof(struct l_rank_st))))
   	{
     		printf("No memory available\n");
     		exit(1);
   	}
	if(upper < lower)
	{
		int tmp;

		tmp = upper;
		upper = lower;
		lower = tmp;
	}
   	n_rank->rankid = rankid;
   	n_rank->upper = upper;
   	n_rank->lower = lower;
   	n_rank->next = (l_rank)NULL;
	if(!list)
		return(n_rank);
	if(list->upper > upper)
	{
		n_rank->next = list;
		return(n_rank);
	}
	ant = new_rank();
	while(adv)
	{
		if(adv->upper > upper)
		{
			l_rank tmp;
			
			tmp = ant->next;
			ant->next = n_rank;
			n_rank->next = tmp;
			return(list);
		}
		else
		{
			ant = adv;
			adv = adv->next;
		}
	}
	ant->next = n_rank;
   	return(list);
}

void print_ranks(l_rank list)
{
   	while(list)
   	{
		printf("%x: %x -> %x\n",
			list->rankid,
			list->lower,
			list->upper);
		list = list->next;
   	}
}

int exists_rank(int rankid, l_rank list)
{
   	while(list)
   	{
		if(rankid == list->rankid)
			return(1);
		list = list->next;
   	}
   	return(0);
}

l_rank free_ranks(l_rank list)
{
   	l_rank tmp;

   	while(list)
   	{
      		tmp = list->next;
      		free(list);
      		list = tmp;
   	} 
   	return((l_rank)NULL);
}

l_rank read_ranks(char *Filename)
{
	FILE *file;
	l_rank list;
	int eof, upper, lower, rankid;

	list = new_rank();
	file = fopen(Filename, "r");
	if(!file)
		return(list);
	eof = 0;
	do{
		eof += freadNum(file, &rankid);
		eof += freadNum(file, &upper);
		eof += freadNum(file, &lower);
		if(!eof)
			list = insert_rank(rankid, upper, lower, list);
	}while(!eof);
	fclose(file);
	return(list);
}


int freadNum(FILE *file, int *num)
{
	char buffer[1024];
	int count, c, number;

	count = 0;
	number = 0;
	if(!file)
		return(1);
	do
	{
		c = fgetc(file);
		if(c != EOF && c != ',' && c != '\n')
			buffer[count++] = (char)c;
	}while(c != EOF && c != '\n' && c != ',' && count < 1024);

	if(!count)
		return(1);

	buffer[count] = '\0';
	number = read_hex(buffer);
	*num = number;
	return(0);
}

int InsideRank(int value, l_rank list)
{
	while(list)
        {
		if(value >= list->lower && value <= list->upper)
			return(list->rankid);
                list = list->next;
        }
        return(0);

}
